#ifndef IFW_INCL
#define IFW_INCL
#include "ietypes.h"

#define THUMBCOL "sclistcol"
#define THUMBTL  "sclisttl"
#define THUMBBR  "sclistbr"

typedef enum {
	iepopup, iewind, iebutton, iedragarea, iegraphic, iefield
	} IEWindObjType;
	
typedef struct {
	IEWindow *cwind;
	IEPopup *cpopup;
	IEWindObjType objtype;
	union {
		IEButton *curbutton;
		IEDragArea *curdrag;
		IEGraphic *curgraphic;
		IEField *curfield;
		} curobj;
	} IECurObj;
	
#define cbutton curobj.curbutton
#define cdrag curobj.curdrag
#define cgraphic curobj.curgraphic
#define cfield curobj.curfield

void DrawInterface(boolean);
void DrawIEWindow(IEWindow *w, int, int, int, int);
void DrawFromWind(IEWindow *w, int clipx, int clipy, int clipwd, int clipht);
void DrawFromPopup(IEPopup *p, int clipx, int clipy, int clipwd, int clipht);
boolean idrag(int x, int y, DragStatusType status);
boolean ikey(int x, int y, char ch);
boolean show_winds();
boolean set_vis_state(char *bname);
boolean vis_save();
#endif
