#include <stdlib.h>
#include <string.h>
#include "geosim.h"
#include "gspriv.h"
#include "aliasw.h"
#include "ietypes.h"
#include "iefile.h"
#include "windfunc.h"
#include "editrec.h"
/*#include "rootw.h"*/
#include "iemisc.h"
#include "helpmsg.h"
/*
	Internal protos
*/
boolean TempAliasIsValid();
void SetupAliasList();
void SetupColorList();
void DisplayCurColor();
void ClearFields();
char *aLabelFunc(int slot);
void textFunc(GSlistHandle list, int slot);
void aInFunc(int);
void aOutFunc(void);
void aClickFunc(int slot);
void aliasChanged() ;/* Text notification func */
char *cLabelFunc(int slot);
void cInFunc() ;
void cOutFunc() ;
void cClickFunc(int slot);
/**/

extern boolean aliaswind;
extern char *IEAlias[], *IEAcolor[];
extern char *IEColorlist[];

static GSlistHandle aliasList, colorList;
static GSsclistHandle aliasScroll, colorScroll;

static int numAliases, numColors;
static int curAlias, curColor;

static EditRec *aliasEdit=NULL;
static BigString tempAlias;
static boolean addEnabled;

extern GSColor redCol, blackCol;

boolean TempAliasIsValid()
{
	return ((tempAlias[0] != '\0')&&(curColor>=0));
}

char *aLabelFunc(int slot)
{
	if (slot < numAliases)
		return IEAlias[slot];
	else
		return "";
}

static void textFunc(GSlistHandle list, int slot)
{	
	if (
		((list == aliasList)&&(slot == curAlias)) ||
		((list == colorList)&&(slot == curColor))
		)
		GSsetcolor(redCol);
	else
		GSsetcolor(blackCol);
	GSsetfont(SMALL);
}

void aInFunc(int i)
{
}

void aOutFunc(void)
{
}

void aClickFunc(int slot)
{
	int old = curAlias;
	if (curAlias >= 0) 
		if (TempAliasIsValid()) {
			strcpy(IEAlias[curAlias], tempAlias);
			strcpy(IEAcolor[curAlias], IEColorlist[curColor]);
			}

	ClearFields();

	curAlias = slot;

/*	curColor = GSconvertcolor(IEAcolor[curAlias]);*/
	curColor = getname(IEColorlist, sizeof(char *), numColors, IEAcolor[curAlias], NULL);
	DisplayCurColor();	

	GSenablebutton("aliasw", "Delalias", TRUE);
	GSdrawlistitem(aliasList, New, curAlias);
	GSdrawlistitem(colorList, New, curColor);
	
	strcpy(tempAlias, IEAlias[slot]);
	aliasEdit->inspt = 0;
	UpdateEditRec(aliasEdit);
}

void aliasChanged() /* Text notification func */
{
}

static char *cLabelFunc(int slot)
{
	if (slot < numColors)
		return IEColorlist[slot];
	else	
		return "";
}

static void cInFunc() 
{
}

static void cOutFunc() 
{
}

static void cClickFunc(int slot)
{
	int old = curColor;
	curColor = slot;
	GSdrawlistitem(colorList, New, old);
	GSdrawlistitem(colorList, New, curAlias);
	DisplayCurColor();
}

void DrawAliasWind()
{
	aliaswind = TRUE;
	GSdrawnamedwindow("aliasw", NO_BSTORE, NO_POPUP);
	GSsetcurrentnamedwindow("aliasw");

	aliasEdit = NewEditRec(tempAlias, BIGSTRINGLEN, 1, SMALL, 
						"aliasw", "alias_edit", 
						c_identifier_filter, aliasChanged);
	SetCurrentEditRec(aliasEdit);
	UpdateEditRec(aliasEdit);
	
	SetupAliasList();
	SetupColorList();
	GSdisablebutton("aliasw", "Delalias", TRUE);
	ClearDragRect("aliasw", "pickrect");
	ClearDragRect("aliasw", "colpickrect");
	GSdrawsclist(aliasScroll);
	GSdrawsclist(colorScroll);
	GSdisablemenuitem("Edit", "edit_aliases");
	GSdisplayhelpmessage(MISC_H);
	ShowVersion();
}

void SetupColorList()
{
	int x, y, wd, dragHt;

	for (numColors = 0; IEColorlist[numColors] != NULL; numColors++);

	GSgetdragareaspecs("aliasw", "colpickrect", &x, &y, 
								&wd, &dragHt, NULL, NULL);
	curColor = -1;
	
	GSsclistsetup("aliasw", "colpickrect",
					1,
					"picklabel",
					0, 0,
					JUST_LEFT,
					cLabelFunc,
					textFunc, 
					cInFunc,
					cOutFunc,
					cClickFunc,
					"colpickscroll",
					GSconvertcolor("sclistcol"),
					GSconvertcolor("sclisttl"),
					GSconvertcolor("sclistbr"),
					numColors, 0, 
					NULL,
					"CUpArrow", "CDownArrow", 
					&colorList, &colorScroll);
							
					
	ShadowRect(x, y, wd, dragHt, THIN, Concave);
	DisplayCurColor();
	GSdrawsclist(colorScroll);
}

void SetupAliasList()
{
	int x, y, wd, dragHt;
	
	for (numAliases = 0;IEAlias[numAliases] != NULL; numAliases++);

	GSgetdragareaspecs("aliasw", "pickrect", &x, &y, 
								&wd, &dragHt, NULL, NULL);
	
	curAlias = -1;
	
	tempAlias[0] = '\0';

	GSsclistsetup("aliasw", "pickrect",
					1, /* num cols */
					"picklabel",
					0, 0, /* col, row gaps */
					JUST_LEFT,
					aLabelFunc,
					textFunc, 
					aInFunc,
					aOutFunc,
					aClickFunc,
					"pickrectscroll",
					GSconvertcolor("sclistcol"),
					GSconvertcolor("sclisttl"),
					GSconvertcolor("sclistbr"),
					numAliases, 0,
					NULL,
					"AUpArrow", "ADownArrow", 
					&aliasList, &aliasScroll);					

					
	ShadowRect(x, y, wd, dragHt, THIN, Concave);
	GSdrawsclist(aliasScroll);
}

void RedrawAliasWind()
{
	int x, y, wd, ht;
	GSgetdragareaspecs("aliasw", "pickrect", 
							&x, &y, &wd, &ht, NULL, NULL);
	GSredrawnamedwindow("aliasw");
	GSsetactivenamedwindow("aliasw");
	GSwclearrect(x, y, wd, ht);
	ShadowRect(x, y, wd, ht, THIN, Concave);
	GSdrawsclist(aliasScroll);

	GSgetdragareaspecs("aliasw", "colpickrect", 
							&x, &y, &wd, &ht, NULL, NULL);
	GSwclearrect(x, y, wd, ht);
	ShadowRect(x, y, wd, ht, THIN, Concave);
	GSdrawsclist(colorScroll);
	UpdateEditRec(aliasEdit);
	DisplayCurColor();
}

void RemoveAliasWind()
{
	if (curAlias >= 0) 
		if (TempAliasIsValid()) {
			strcpy(IEAlias[curAlias], tempAlias);
			strcpy(IEAcolor[curAlias], IEColorlist[curColor]);
			}
	
	ClearFields();
	aliaswind = FALSE;
	GSdismantlesclist(aliasScroll);
	GSdismantlesclist(colorScroll);
	DisposEditRec(aliasEdit);
	aliasEdit = NULL;
	GSremovenamedwindow("aliasw");
	GSredrawnamedwindow("root");
	GSredrawnamedwindow("message");
	GSenablemenuitem("Edit", "edit_aliases");
}

boolean alias_pick(int x, int y, DragStatusType status)
{
	GShandlelist(aliasList, x, y, status);
	return TRUE;
}

boolean color_pick(int x, int y, DragStatusType status)
{
	GShandlelist(colorList, x, y, status);
	return TRUE;
}

boolean alias_scroll(int x, int y, DragStatusType status)
{
	GShandlesclist(aliasScroll, x, y, status);
	return TRUE;
}

boolean color_scroll(int x, int y, DragStatusType status)
{
	GShandlesclist(colorScroll, x, y, status);
	return TRUE;
}

boolean edit_alias_field(int x, int y, DragStatusType status)
{
	if (aliasEdit == NULL)
		return FALSE;
	if ((status == MOUSE_CLICK) || (status == DRAG_FINAL))
		SetCurrentEditRec(aliasEdit);
}

boolean new_alias()
{
	/*	When user clicks new, if cur item,
	change item stuff.  If no cur item, and
	a color & name are present, add item.
	Redraw the list.
	*/
	
	if (curAlias >= 0) {
		if (TempAliasIsValid()) {
			strcpy(IEAlias[curAlias], tempAlias);
			if (curColor >= 0)
				strcpy(IEAcolor[curAlias], IEColorlist[curColor]);
			}
		}
	else if (TempAliasIsValid()) {
		/*free(IEAlias[numAliases]);*/
		IEAlias[numAliases] = str_dup(tempAlias);
		IEAcolor[numAliases] = str_dup(IEColorlist[curColor]);
		numAliases++;
		IEAlias[numAliases] = NULL;
		curAlias = -1;
		GSsetsclistnumitems(aliasScroll, numAliases, TRUE);
		}
	ClearFields();
}

boolean delete_alias(void)
{
	int i;
	
	free(IEAlias[curAlias]);
	free(IEAcolor[curAlias]);
	
	for (i=curAlias; i < numAliases; i++) {
		IEAlias[i] = IEAlias[i+1];
		IEAcolor[i] = IEAcolor[i+1];
		}

	numAliases--;

	GSsetsclistnumitems(aliasScroll, numAliases, TRUE);

	ClearFields();
}

void DisplayCurColor()
{
/*	int x, y, wd, ht, tht;
	GSColor col;
	
	GSsetcurrentnamedwindow("aliasw");
	GSgetfieldrect("cur_color", &x, &y, &wd, &ht, &col);
	
	GSsetcolor(GSconvertcolor("white"));
	GSwfillrect(x, y, wd, ht);
	
	GSsetcolor(col);
	GSsetfont(SMALL);
	tht = GStextheight(NULL);

	ShadowRect(x, y, wd, ht, THIN, Concave);
	if (curColor >= 0)	
		GSwwritemsg(x, y + ((ht+tht)/2), IEColorlist[curColor]);
	if (curColor >= 0)
		GSdrawlistitem(colorList, New, curColor);*/
	DrawTextField("cur_color", 
		(curColor >= 0)? IEColorlist[curColor] : " ");
}

void ClearFields()
{
	int old;
	old = curAlias;
	curAlias = -1;
	if (old>=0)
		GSdrawlistitem(aliasList, New, old);
	
	old = curColor;
	curColor = -1;
	if (old>=0)
		GSdrawlistitem(colorList, New, old);
	
	tempAlias[0] = '\0';
	aliasEdit->inspt = 0;
	GSdisablebutton("aliasw", "Delalias", TRUE);
	DisplayCurColor();
	UpdateEditRec(aliasEdit);
}

void ClearDragRect(char *wname, char *dname)
{
	int x, y, wd, ht;
	GSColor col;
	
	GSgetdragareaspecs(wname, dname, &x, &y, &wd ,&ht, NULL, &col);
	GSsetcolor(col);
	GSwfillrect(x, y, wd, ht);
}

boolean alias_up()
{
	GShandleupbutton(aliasScroll);
}

boolean alias_down()
{
	GShandledownbutton(aliasScroll);
}

boolean col_up()
{
	GShandleupbutton(colorScroll);
}

boolean col_down()
{
	GShandledownbutton(colorScroll);
}